using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using System.Globalization;

namespace Google_Maps_Download
{
    public partial class LatLonToTiles : Form
    {
        LatLonXYcalcs LLXY = new LatLonXYcalcs();

        public LatLonToTiles(string zoom)
        {
            InitializeComponent();

            Mzoom.Text = zoom;
        }

        private void Mzoom_TextChanged(object sender, EventArgs e)
        {
            CalculateXY();
        }

        private void poiLat_TextChanged(object sender, EventArgs e)
        {
            string the_text = poiLat.Text;
            if (the_text.IndexOf(" ") != -1)
            {
                if (the_text.Length - the_text.IndexOf(" ") == 3)
                {
                    decimal hours = Decimal.Parse(the_text.Substring(0, the_text.IndexOf(" ")));
                    decimal minutes = Decimal.Parse(the_text.Substring(the_text.IndexOf(" ") + 1, the_text.Length - 1 - the_text.IndexOf(" ")));

                    poiLat.Text = (hours + minutes / 60).ToString("0.000000");
                }
            }

            CalculateXY();
        }

        private void poiLon_TextChanged(object sender, EventArgs e)
        {
            string the_text = poiLon.Text;
            if (the_text.IndexOf(" ") != -1)
            {
                if (the_text.Length - the_text.IndexOf(" ") == 3)
                {
                    decimal hours = Decimal.Parse(the_text.Substring(0, the_text.IndexOf(" ")));
                    decimal minutes = Decimal.Parse(the_text.Substring(the_text.IndexOf(" ") + 1, the_text.Length - 1 - the_text.IndexOf(" ")));

                    poiLon.Text = (hours + minutes / 60).ToString("0.000000");
                }
            }

            CalculateXY();
        }

        private void CalculateXY()
        {
            try
            {
                decimal lat = Decimal.Parse(poiLat.Text.Trim(), NumberFormatInfo.InvariantInfo);
                decimal lon = Decimal.Parse(poiLon.Text.Trim(), NumberFormatInfo.InvariantInfo);
                decimal zoom = Decimal.Parse(Mzoom.Text.Trim(), NumberFormatInfo.InvariantInfo);

                int[] XY = LLXY.CalculateXY(lat, lon, zoom);

                Mx.Text = XY[0].ToString();
                My.Text = XY[1].ToString();
            }
            catch
            {
                Mx.Text = "";
                My.Text = "";
            }
        }

        private void btnAccept_Click(object sender, EventArgs e)
        {
            Mzoom.Text = Mzoom.Text.Trim();
            this.Close();
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            Mzoom.Text = "";
            Mx.Text = "";
            My.Text = "";
            this.Close();
        }
    }
}