using System;
using System.Collections.Generic;
using System.Text;

namespace Google_Maps_Download
{
    class LatLonXYcalcs
    {
        #region borrowed code
        // this seems to work (ref http://mapki.com/getLonLat.php)
        public decimal[] getLatLong(int x, int y, int zoom)
        {
            double lon = -180; // x
            double lonWidth = 360; // width 360

            double lat = -1;
            double latHeight = 2;

            int tilesAtThisZoom = 1 << (17 - zoom);
            lonWidth = 360.0 / tilesAtThisZoom;
            lon = -180 + (x * lonWidth);
            latHeight = -2.0 / tilesAtThisZoom;
            lat = 1 + (y * latHeight);

            // convert lat and latHeight to degrees in a transverse mercator projection
            // note that in fact the coordinates go from about -85 to +85 not -90 to 90!
            latHeight += lat;
            latHeight = (2 * Math.Atan(Math.Exp(Math.PI * latHeight))) - (Math.PI / 2);
            latHeight *= (180 / Math.PI);

            lat = (2 * Math.Atan(Math.Exp(Math.PI * lat))) - (Math.PI / 2);
            lat *= (180 / Math.PI);

            latHeight -= lat;

            if (lonWidth < 0)
            {
                lon = lon + lonWidth;
                lonWidth = -lonWidth;
            }

            if (latHeight < 0)
            {
                lat = lat + latHeight;
                latHeight = -latHeight;
            }

            //Coord c;
            //c.lat = lat;
            //c.lon = lon;
            //c.lonWidth = lonWidth;
            //c.latHeight = latHeight;
            return new decimal[] { (decimal)lon, (decimal)lat + (decimal)latHeight };
        }
        #endregion

        public int[] CalculateXY(decimal lat, decimal lon, decimal zoom)
        {
            int our_zoom = 16;
            int our_x = 0; // at 17
            int our_y = 0;

            while (our_zoom >= zoom)
            {
                decimal[] TL = getLatLong(our_x * 2, our_y * 2, our_zoom);
                decimal[] MM = getLatLong(our_x * 2 + 1, our_y * 2 + 1, our_zoom);
                decimal[] BR = getLatLong(our_x * 2 + 2, our_y * 2 + 2, our_zoom);

                decimal Lon1 = TL[0];
                decimal Lon2 = MM[0];
                decimal Lon3 = BR[0];

                decimal Lat1 = TL[1];
                decimal Lat2 = MM[1];
                decimal Lat3 = BR[1];

                if (lat < Lat1 && lat > Lat2 && lon > Lon1 && lon < Lon2)
                {
                    our_x = our_x * 2;
                    our_y = our_y * 2;
                }
                if (lat < Lat2 && lat > Lat3 && lon > Lon2 && lon < Lon3)
                {
                    our_x = our_x * 2 + 1;
                    our_y = our_y * 2 + 1;
                }
                if (lat < Lat1 && lat > Lat2 && lon > Lon2 && lon < Lon3)
                {
                    our_x = our_x * 2 + 1;
                    our_y = our_y * 2;
                }
                if (lat < Lat2 && lat > Lat3 && lon > Lon1 && lon < Lon2)
                {
                    our_x = our_x * 2;
                    our_y = our_y * 2 + 1;
                }

                our_zoom--;
            }

            return new int[] { our_x, our_y };
        }

        // this seems to round wrong (try? http://cfis.savagexi.com/articles/2006/05/03/google-maps-deconstructed)
        /*private int[] CalculateXY(decimal lat, decimal lon, decimal zoom)
        {
            #region borrowed code

            decimal bc = (decimal)6.28318530717958652866;
            decimal Wa = (decimal)0.017453292519943295912944444444444;

            decimal c = 256;
            decimal d = 17;

            decimal pixelsPerLonDegree = 0;
            decimal pixelsPerLonRadian = 0;
            decimal bitmapOrigo = 0;

            while (d >= zoom)
            {
                d = d - 1;
                pixelsPerLonDegree = c / 360;
                pixelsPerLonRadian = c / bc;
                bitmapOrigo = c / 2;
                c = c * 2;
            }

            decimal x = (bitmapOrigo + lon * pixelsPerLonDegree) / 256;
            decimal e = (decimal)Math.Sin(System.Convert.ToDouble(lat * Wa));
            decimal y = (bitmapOrigo + (decimal)0.5 * (decimal)Math.Log(System.Convert.ToDouble((1 + (e)) / (1 - (e)))) * -1 * pixelsPerLonRadian) / 256;
            #endregion

            return new int[] { Int32.Parse(x.ToString("0")), Int32.Parse(y.ToString("0")) };
        }*/
    }
}
