using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Google_Maps_Download
{
    public partial class SelectDetail4x : Form
    {
        public SelectDetail4x(int zoom, int min_zoom, int x, int y, string map_type)
        {
            InitializeComponent();

            Zoom = zoom;
            MinZoom = min_zoom;
            X = x;
            Y = y;
            MapType = map_type;
        }

        private int Zoom;
        private int MinZoom;
        private int X;
        private int Y;
        private string MapType;

        private void SelectDetail4x_Load(object sender, EventArgs e)
        {
            mapURL mu = new mapURL();

            for (int i = 0; i < 8; i++)
            {
                for (int j = 0; j < 8; j++)
                {
                    CheckBox cb = new CheckBox();
                    cb.Location = new Point(0 + i * 128 + 64, 24 + j * 128 + 64);
                    cb.Checked = true;
                    cb.Width = 20;
                    cb.Name = "cb" + (X * 4 + i).ToString() + "_" + (Y * 4 + j).ToString();
                    this.Controls.Add(cb);

                    PictureBox pb = new PictureBox();
                    pb.Location = new Point(0 + i * 128, 24 + j * 128);
                    pb.Width = 128;
                    pb.Height = 128;
                    pb.SizeMode = PictureBoxSizeMode.StretchImage;
                    pb.BorderStyle = BorderStyle.FixedSingle;
                    pb.LoadAsync(mu.MapByType(Zoom - 2, X*4 + i, Y*4 + j, MapType));
                    this.Controls.Add(pb);
                }
            }
        }

        public DataTable TilesToIgnore;

        private void Done_Click(object sender, EventArgs e)
        {
            TilesToIgnore = new DataTable();
            TilesToIgnore.Columns.Add("zoom", typeof(Int32));
            TilesToIgnore.Columns.Add("x", typeof(Int32));
            TilesToIgnore.Columns.Add("y", typeof(Int32));

            foreach (Control cn in this.Controls)
            {
                if (cn.Name.StartsWith("cb"))
                {
                    if (((CheckBox)cn).Checked == false)
                    {
                        int x = Int32.Parse(cn.Name.Substring(2, cn.Name.IndexOf("_") - 2));
                        int y = Int32.Parse(cn.Name.Substring(cn.Name.IndexOf("_") + 1, cn.Name.Length - 1 - cn.Name.IndexOf("_")));
                        int zoom_span = 2;
                        for (int zoom_off = 3; Zoom - zoom_off >= MinZoom; zoom_off++, zoom_span*=2)
                        {
                            for (int x_span = 0; x_span < zoom_span; x_span++)
                            {
                                for (int y_span = 0; y_span < zoom_span; y_span++)
                                {
                                    DataRow new_row = TilesToIgnore.NewRow();
                                    new_row["zoom"] = Zoom - zoom_off;
                                    new_row["x"] = x * zoom_span + x_span;
                                    new_row["y"] = y * zoom_span + y_span;
                                    TilesToIgnore.Rows.Add(new_row);
                                }
                            }
                        }
                    }
                }
            }

            this.Close();
        }
    }
}